<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVoiceAccessLevelMapping ArrayType
 * @subpackage Arrays
 */
class ArrayOfVoiceAccessLevelMapping extends AbstractStructArrayBase
{
    /**
     * The VoiceAccessLevelMapping
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\VoiceAccessLevelMapping[]
     */
    public $VoiceAccessLevelMapping;
    /**
     * Constructor method for ArrayOfVoiceAccessLevelMapping
     * @uses ArrayOfVoiceAccessLevelMapping::setVoiceAccessLevelMapping()
     * @param \CustomerManagement\StructType\VoiceAccessLevelMapping[] $voiceAccessLevelMapping
     */
    public function __construct(array $voiceAccessLevelMapping = array())
    {
        $this
            ->setVoiceAccessLevelMapping($voiceAccessLevelMapping);
    }
    /**
     * Get VoiceAccessLevelMapping value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\VoiceAccessLevelMapping[]|null
     */
    public function getVoiceAccessLevelMapping()
    {
        return isset($this->VoiceAccessLevelMapping) ? $this->VoiceAccessLevelMapping : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVoiceAccessLevelMapping method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVoiceAccessLevelMapping method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVoiceAccessLevelMappingForArrayConstraintsFromSetVoiceAccessLevelMapping(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVoiceAccessLevelMappingVoiceAccessLevelMappingItem) {
            // validation for constraint: itemType
            if (!$arrayOfVoiceAccessLevelMappingVoiceAccessLevelMappingItem instanceof \CustomerManagement\StructType\VoiceAccessLevelMapping) {
                $invalidValues[] = is_object($arrayOfVoiceAccessLevelMappingVoiceAccessLevelMappingItem) ? get_class($arrayOfVoiceAccessLevelMappingVoiceAccessLevelMappingItem) : sprintf('%s(%s)', gettype($arrayOfVoiceAccessLevelMappingVoiceAccessLevelMappingItem), var_export($arrayOfVoiceAccessLevelMappingVoiceAccessLevelMappingItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VoiceAccessLevelMapping property can only contain items of type \CustomerManagement\StructType\VoiceAccessLevelMapping, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VoiceAccessLevelMapping value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\VoiceAccessLevelMapping[] $voiceAccessLevelMapping
     * @return \CustomerManagement\ArrayType\ArrayOfVoiceAccessLevelMapping
     */
    public function setVoiceAccessLevelMapping(array $voiceAccessLevelMapping = array())
    {
        // validation for constraint: array
        if ('' !== ($voiceAccessLevelMappingArrayErrorMessage = self::validateVoiceAccessLevelMappingForArrayConstraintsFromSetVoiceAccessLevelMapping($voiceAccessLevelMapping))) {
            throw new \InvalidArgumentException($voiceAccessLevelMappingArrayErrorMessage, __LINE__);
        }
        if (is_null($voiceAccessLevelMapping) || (is_array($voiceAccessLevelMapping) && empty($voiceAccessLevelMapping))) {
            unset($this->VoiceAccessLevelMapping);
        } else {
            $this->VoiceAccessLevelMapping = $voiceAccessLevelMapping;
        }
        return $this;
    }
    /**
     * Add item to VoiceAccessLevelMapping value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\VoiceAccessLevelMapping $item
     * @return \CustomerManagement\ArrayType\ArrayOfVoiceAccessLevelMapping
     */
    public function addToVoiceAccessLevelMapping(\CustomerManagement\StructType\VoiceAccessLevelMapping $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\VoiceAccessLevelMapping) {
            throw new \InvalidArgumentException(sprintf('The VoiceAccessLevelMapping property can only contain items of type \CustomerManagement\StructType\VoiceAccessLevelMapping, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VoiceAccessLevelMapping[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\VoiceAccessLevelMapping|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\VoiceAccessLevelMapping|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\VoiceAccessLevelMapping|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\VoiceAccessLevelMapping|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\VoiceAccessLevelMapping|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VoiceAccessLevelMapping
     */
    public function getAttributeName()
    {
        return 'VoiceAccessLevelMapping';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfVoiceAccessLevelMapping
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
